public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Ionen Wolkens" <ionen@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: dev-games/godot/
Date: Tue, 30 Aug 2022 21:48:30 +0000 (UTC)	[thread overview]
Message-ID: <1661896096.88d90946b566fdd539ceecaf978b5b8998dcf67a.ionen@gentoo> (raw)

commit:     88d90946b566fdd539ceecaf978b5b8998dcf67a
Author:     Ionen Wolkens <ionen <AT> gentoo <DOT> org>
AuthorDate: Tue Aug 30 19:45:16 2022 +0000
Commit:     Ionen Wolkens <ionen <AT> gentoo <DOT> org>
CommitDate: Tue Aug 30 21:48:16 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=88d90946

dev-games/godot: add 4.0_alpha15, unkeyworded

Signed-off-by: Ionen Wolkens <ionen <AT> gentoo.org>

 dev-games/godot/Manifest                 |   1 +
 dev-games/godot/godot-4.0_alpha15.ebuild | 256 +++++++++++++++++++++++++++++++
 2 files changed, 257 insertions(+)

diff --git a/dev-games/godot/Manifest b/dev-games/godot/Manifest
index 9d7912698ebb..e9361cee93fb 100644
--- a/dev-games/godot/Manifest
+++ b/dev-games/godot/Manifest
@@ -1,2 +1,3 @@
 DIST godot-3.5-stable.tar.xz 24044340 BLAKE2B 9d77ecdfa6bd90065fff26c2334f13c32bbbc4b26aad111b5aab2563d1e4782457ea6cf2115f1a809e0d8aac3d3ee9a138ad224998068983ad36e54a577d89c3 SHA512 23785e39ccc7e1406c97ee33b5e90f7f397aa907d79d72ed08ea3f4b7e68788030a1bcdd07c9f782a21ee3a84636a2cea47a57dcfc94c24e327fa210ae0515b0
 DIST godot-4.0-alpha14.tar.xz 30970116 BLAKE2B 213616f3a80f97c09580324bf9296d12b6213a2941b3070353b45e160dc7d7bfd32fcae3fc2b64a91fa7d935c23d97fd02a015bc3501441d67261ee6e45e85e1 SHA512 511cb5d3f48c747232350bee25765c17032b99179fd70877f906bcd1a09449260a928c3df9f84c6f3afb47f564b8f4bf75d0a07d37f5a22dd5f5a96d1b1f4df5
+DIST godot-4.0-alpha15.tar.xz 30959600 BLAKE2B 0631519d81147d64a01b543111b8317c436d4070f27cf54801a68a66b8d380e5ce33b85a78f09547ffc1b2573f9ac0c7860712808380849c26a0336c89d1c7f4 SHA512 47c750062e4e8262ee95e5b0337744e86b0092789a62c3847d27ab929281c414e5ca1d666a1f03f0a180203ee0f78f53e311976b52d54ee9f8a7b266afa3beb0

diff --git a/dev-games/godot/godot-4.0_alpha15.ebuild b/dev-games/godot/godot-4.0_alpha15.ebuild
new file mode 100644
index 000000000000..02df805c8f56
--- /dev/null
+++ b/dev-games/godot/godot-4.0_alpha15.ebuild
@@ -0,0 +1,256 @@
+# Copyright 2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{8..10} )
+inherit bash-completion-r1 desktop python-any-r1 scons-utils toolchain-funcs xdg
+
+MY_P="${PN}-$(ver_rs 2 -)"
+
+DESCRIPTION="Multi-platform 2D and 3D game engine with a feature-rich editor"
+HOMEPAGE="https://godotengine.org/"
+SRC_URI="https://downloads.tuxfamily.org/godotengine/$(ver_rs 2 /)/${MY_P}.tar.xz"
+S="${WORKDIR}/${MY_P}"
+
+LICENSE="
+	MIT
+	Apache-2.0 BSD Boost-1.0 CC0-1.0 Unlicense ZLIB
+	gui? ( CC-BY-4.0 ) tools? ( OFL-1.1 )"
+SLOT="4"
+#KEYWORDS="~amd64" # leaving 4 unkeyworded until at least first _beta
+# Enable roughly same as upstream by default so it works as expected,
+# except raycast (tools-only heavy dependency), and deprecated.
+IUSE="
+	+dbus debug deprecated +fontconfig +gui pulseaudio raycast
+	+runner speech test +theora +tools +udev +upnp +webp"
+RESTRICT="!test? ( test ) !tools? ( test ) !webp? ( test )"
+
+# dlopen: alsa-lib,dbus,fontconfig,pulseaudio,speech-dispatcher,udev
+RDEPEND="
+	app-arch/zstd:=
+	dev-games/recastnavigation:=
+	dev-libs/icu:=
+	dev-libs/libpcre2:=[pcre32]
+	media-libs/freetype[brotli,harfbuzz]
+	media-libs/harfbuzz:=[icu]
+	media-libs/libogg
+	media-libs/libpng:=
+	media-libs/libvorbis
+	<net-libs/mbedtls-3:=
+	net-libs/wslay
+	sys-libs/zlib:=
+	fontconfig? ( media-libs/fontconfig )
+	gui? (
+		dev-util/glslang
+		media-libs/alsa-lib
+		media-libs/libglvnd[X]
+		media-libs/vulkan-loader[X]
+		x11-libs/libX11
+		x11-libs/libXcursor
+		x11-libs/libXext
+		x11-libs/libXi
+		x11-libs/libXinerama
+		x11-libs/libXrandr
+		x11-libs/libXrender
+		dbus? ( sys-apps/dbus )
+		pulseaudio? ( media-libs/libpulse )
+		tools? ( raycast? ( media-libs/embree:3 ) )
+		udev? ( virtual/udev )
+	)
+	speech? ( app-accessibility/speech-dispatcher )
+	theora? ( media-libs/libtheora )
+	tools? ( app-misc/ca-certificates )
+	upnp? ( net-libs/miniupnpc:= )
+	webp? ( media-libs/libwebp:= )"
+DEPEND="
+	${RDEPEND}
+	gui? (
+		dev-util/vulkan-headers
+		x11-base/xorg-proto
+	)
+	tools? ( test? ( dev-cpp/doctest ) )"
+BDEPEND="virtual/pkgconfig"
+
+PATCHES=(
+	"${FILESDIR}"/${PN}-4.0-musl.patch
+	"${FILESDIR}"/${PN}-4.0_alpha14-scons.patch
+)
+
+src_prepare() {
+	default
+
+	sed -i "1,5s/ godot/&${SLOT}/i" misc/dist/linux/godot.6 || die
+	sed -i "/id/s/Godot/&${SLOT}/" misc/dist/linux/org.godotengine.Godot.appdata.xml || die
+	sed -e "s/=godot/&${SLOT}/" -e "/^Name=/s/$/ ${SLOT}/" \
+		-i misc/dist/linux/org.godotengine.Godot.desktop || die
+
+	sed -i "s|pkg-config |$(tc-getPKG_CONFIG) |" platform/linuxbsd/detect.py || die
+
+	# use of builtin_ switches can be messy (see below), delete to be sure
+	local unbundle=(
+		doctest embree freetype glslang graphite harfbuzz icu4c libogg libpng
+		libtheora libvorbis libwebp mbedtls miniupnpc pcre2 recastnavigation
+		volk vulkan/include wslay zlib zstd
+		# certs: unused by generated header, but scons panics if not found
+	)
+	rm -r "${unbundle[@]/#/thirdparty/}" || die
+
+	# do symlinks to avoid too much patching with hardcoded header paths
+	mkdir thirdparty/lib{vorbis,ogg} || die
+	ln -s "${ESYSROOT}"/usr/include thirdparty/zstd || die
+	ln -s "${ESYSROOT}"/usr/include/doctest thirdparty/ || die
+	ln -s "${ESYSROOT}"/usr/include/ogg thirdparty/libogg/ || die
+	ln -s "${ESYSROOT}"/usr/include/vorbis thirdparty/libvorbis/ || die
+}
+
+src_compile() {
+	local -x GODOT_VERSION_STATUS=$(ver_cut 3-4) # for dev versions only
+	local -x BUILD_NAME=gentoo # replaces "custom_build" in version string
+
+	local esconsargs=(
+		AR="$(tc-getAR)" CC="$(tc-getCC)" CXX="$(tc-getCXX)"
+
+		progress=no
+		verbose=yes
+
+		deprecated=$(usex deprecated)
+		#execinfo=$(usex !elibc_glibc) # libexecinfo is not packaged
+		fontconfig=$(usex fontconfig)
+		minizip=yes # uses a modified bundled copy
+		opengl3=$(usex gui)
+		pulseaudio=$(usex gui $(usex pulseaudio))
+		speechd=$(usex speech)
+		udev=$(usex gui $(usex udev))
+		use_dbus=$(usex gui $(usex dbus))
+		use_volk=no # unnecessary when linking directly to libvulkan
+		vulkan=$(usex gui) # hard-required and favored by upstream over gles3
+		x11=$(usex gui)
+
+		system_certs_path="${EPREFIX}"/etc/ssl/certs/ca-certificates.crt
+
+		# platform/*/detect.py uses builtin_* switches to check if need
+		# to link with system libraries, but ignores whether the dep is
+		# actually used, so "enable" deleted builtins on disabled deps
+		builtin_certs=no
+		builtin_embree=$(usex !gui yes $(usex !tools yes $(usex !raycast)))
+		builtin_enet=yes # bundled copy is patched for IPv6+DTLS support
+		builtin_freetype=no
+		builtin_glslang=$(usex !gui)
+		builtin_graphite=no
+		builtin_harfbuzz=no
+		builtin_icu=no
+		builtin_libogg=no
+		builtin_libpng=no
+		builtin_libtheora=$(usex !theora)
+		builtin_libvorbis=no
+		builtin_libwebp=$(usex !webp)
+		builtin_mbedtls=no
+		builtin_miniupnpc=$(usex !upnp)
+		builtin_msdfgen=yes # not wired for unbundling nor packaged
+		builtin_pcre2=no
+		builtin_recast=no
+		builtin_rvo2=yes # bundled copy has godot-specific changes
+		builtin_squish=yes # ^ likewise, may not be safe to unbundle
+		builtin_wslay=no
+		builtin_xatlas=yes # not wired for unbundling nor packaged
+		builtin_zlib=no
+		builtin_zstd=no
+		# also bundled but lacking a builtin_* switch:
+		#	amd-fsr, basis_universal, cvtt, etcpak, fonts, glad,
+		#	jpeg-compressor, meshoptimizer, minimp3, minizip (patched to
+		#	seek in archives), noise, oidn, openxr, spirv-reflect, thorvg,
+		#	tinyexr, vhacd, vulkan (minus include/) and the misc directory.
+
+		# modules with optional dependencies, "possible" to disable more but
+		# gets messy and breaks all sorts of features (expected enabled)
+		module_glslang_enabled=$(usex gui)
+		module_gridmap_enabled=$(usex deprecated) # fails without deprecated
+		module_mono_enabled=no # unhandled
+		# note raycast is disabled on many arches, see raycast/config.py
+		module_raycast_enabled=$(usex gui $(usex tools $(usex raycast)))
+		module_theora_enabled=$(usex theora)
+		module_upnp_enabled=$(usex upnp)
+		module_webp_enabled=$(usex webp)
+
+		# let *FLAGS handle these, e.g. can pass -flto as-is
+		debug_symbols=no
+		optimize=none
+		use_lto=no
+		use_static_cpp=no
+	)
+
+	if use runner && use tools; then
+		# build alternate faster + ~60% smaller binary for running
+		# games or servers without game development debug paths
+		escons extra_suffix=runner target=release tools=no "${esconsargs[@]}"
+	fi
+
+	esconsargs+=(
+		# debug: debug for godot itself
+		# release_debug: debug for game development
+		# release: no debugging paths, only available with tools=no
+		target=$(usex debug{,} $(usex tools release_debug release))
+		tools=$(usex tools)
+
+		# harmless but note this bakes in --test in the final binary
+		tests=$(usex tools $(usex test))
+	)
+
+	escons extra_suffix=main "${esconsargs[@]}"
+}
+
+src_test() {
+	xdg_environment_reset
+	bin/godot*.main --headless --test || die
+}
+
+src_install() {
+	local s=godot${SLOT}
+
+	newbin bin/godot*.main ${s}
+	if use runner && use tools; then
+		newbin bin/godot*.runner ${s}-runner
+	else
+		# always available, revdeps shouldn't depend on [runner]
+		dosym ${s} /usr/bin/${s}-runner
+	fi
+
+	newman misc/dist/linux/godot.6 ${s}.6
+	dodoc AUTHORS.md CHANGELOG.md DONORS.md README.md
+
+	if use gui; then
+		newicon icon.svg ${s}.svg
+		newmenu misc/dist/linux/org.godotengine.Godot.desktop \
+			org.godotengine.${s^}.desktop
+
+		insinto /usr/share/metainfo
+		newins misc/dist/linux/org.godotengine.Godot.appdata.xml \
+			org.godotengine.${s^}.appdata.xml
+
+		insinto /usr/share/mime/application
+		newins misc/dist/linux/org.godotengine.Godot.xml \
+			org.godotengine.${s^}.xml
+	fi
+
+	newbashcomp misc/dist/shell/godot.bash-completion ${s}
+	bashcomp_alias ${s}{,-runner}
+
+	insinto /usr/share/fish/vendor_completions.d
+	newins misc/dist/shell/godot.fish ${s}.fish
+	dosym ${s}.fish /usr/share/fish/vendor_completions.d/${s}-runner.fish
+
+	insinto /usr/share/zsh/site-functions
+	newins misc/dist/shell/_godot.zsh-completion _${s}
+	dosym _${s} /usr/share/zsh/site-functions/_${s}-runner
+}
+
+pkg_postinst() {
+	xdg_pkg_postinst
+
+	if [[ ! ${REPLACING_VERSIONS} ]] && has_version ${CATEGORY}/${PN}:3; then
+		elog
+		elog "Remember to make backups before opening any Godot <=3.x projects in Godot 4."
+		elog "Automated migration is only partial, and it would be difficult to revert."
+	fi
+}


             reply	other threads:[~2022-08-30 21:48 UTC|newest]

Thread overview: 71+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2022-08-30 21:48 Ionen Wolkens [this message]
  -- strict thread matches above, loose matches on Subject: below --
2024-08-29  5:16 [gentoo-commits] repo/gentoo:master commit in: dev-games/godot/ Ionen Wolkens
2024-06-11 14:46 Ionen Wolkens
2024-04-18  5:14 Ionen Wolkens
2024-03-26 17:30 Ionen Wolkens
2024-03-26 17:30 Ionen Wolkens
2024-03-26 17:30 Ionen Wolkens
2024-03-26 17:30 Ionen Wolkens
2023-12-12 13:17 Ionen Wolkens
2023-11-30 11:52 Ionen Wolkens
2023-11-09 15:49 Ionen Wolkens
2023-11-02  0:05 Ionen Wolkens
2023-11-02  0:05 Ionen Wolkens
2023-10-04 14:25 Ionen Wolkens
2023-08-03 11:58 Ionen Wolkens
2023-07-18 19:11 Ionen Wolkens
2023-07-18 19:11 Ionen Wolkens
2023-05-26 23:16 Ionen Wolkens
2023-05-23  2:52 Sam James
2023-05-19 12:46 Ionen Wolkens
2023-04-17 20:45 Ionen Wolkens
2023-04-04 13:08 Ionen Wolkens
2023-03-20 21:04 Ionen Wolkens
2023-03-07 10:24 Ionen Wolkens
2023-03-01 14:23 Ionen Wolkens
2023-03-01 14:23 Ionen Wolkens
2023-02-25 12:16 Ionen Wolkens
2023-02-25 12:16 Ionen Wolkens
2023-02-24 10:17 Ionen Wolkens
2023-02-15  6:25 Ionen Wolkens
2023-02-08 17:36 Ionen Wolkens
2023-02-08 17:36 Ionen Wolkens
2023-02-02 17:26 Ionen Wolkens
2023-01-28  6:04 Ionen Wolkens
2023-01-28  6:04 Ionen Wolkens
2023-01-25 15:31 Ionen Wolkens
2023-01-25 15:31 Ionen Wolkens
2023-01-21 10:01 Ionen Wolkens
2023-01-21 10:01 Ionen Wolkens
2023-01-18 15:51 Ionen Wolkens
2023-01-18 12:03 Ionen Wolkens
2023-01-18 12:03 Ionen Wolkens
2023-01-14  7:32 Ionen Wolkens
2023-01-14  7:32 Ionen Wolkens
2023-01-11 11:26 Ionen Wolkens
2022-12-29 20:29 Ionen Wolkens
2022-12-24  6:04 Ionen Wolkens
2022-12-24  6:04 Ionen Wolkens
2022-12-20  6:44 Ionen Wolkens
2022-12-16  0:10 Ionen Wolkens
2022-12-10  9:39 Ionen Wolkens
2022-12-02  3:18 Ionen Wolkens
2022-12-02  3:18 Ionen Wolkens
2022-12-02  3:18 Ionen Wolkens
2022-11-24  6:35 Ionen Wolkens
2022-11-24  6:35 Ionen Wolkens
2022-11-16 20:31 Ionen Wolkens
2022-11-05 21:43 Ionen Wolkens
2022-11-02  7:33 Ionen Wolkens
2022-11-02  5:38 Ionen Wolkens
2022-11-01 20:39 Ionen Wolkens
2022-10-15  5:23 Ionen Wolkens
2022-10-09  0:29 Ionen Wolkens
2022-09-30 12:42 Ionen Wolkens
2022-09-28 13:53 Ionen Wolkens
2022-09-16  6:15 Ionen Wolkens
2022-09-16  6:15 Ionen Wolkens
2022-09-14  4:05 Ionen Wolkens
2022-09-14  4:05 Ionen Wolkens
2022-09-07 21:47 Ionen Wolkens
2022-08-30 21:48 Ionen Wolkens

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1661896096.88d90946b566fdd539ceecaf978b5b8998dcf67a.ionen@gentoo \
    --to=ionen@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox